<?xml version="1.0" encoding="ascii"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
          "DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
  <title>screenlets.plugins.Gstreamer</title>
  <link rel="stylesheet" href="epydoc.css" type="text/css" />
  <script type="text/javascript" src="epydoc.js"></script>
</head>

<body bgcolor="white" text="black" link="blue" vlink="#204080"
      alink="#204080">
<!-- ==================== NAVIGATION BAR ==================== -->
<table class="navbar" border="0" width="100%" cellpadding="0"
       bgcolor="#a0c0ff" cellspacing="0">
  <tr valign="middle">
  <!-- Home link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="screenlets-module.html">Home</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Tree link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="module-tree.html">Trees</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Index link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="identifier-index.html">Indices</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Help link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="help.html">Help</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Project homepage -->
      <th class="navbar" align="right" width="100%">
        <table border="0" cellpadding="0" cellspacing="0">
          <tr><th class="navbar" align="center"
            >Screenlets 0.1.2</th>
          </tr></table></th>
  </tr>
</table>
<table width="100%" cellpadding="0" cellspacing="0">
  <tr valign="top">
    <td width="100%">
      <span class="breadcrumbs">
        <a href="screenlets-module.html">Package&nbsp;screenlets</a> ::
        <a href="screenlets.plugins-module.html">Package&nbsp;plugins</a> ::
        Module&nbsp;Gstreamer
      </span>
    </td>
    <td>
      <table cellpadding="0" cellspacing="0">
        <!-- hide/show private -->
        <tr><td align="right"><span class="options">[<a href="javascript:void(0);" class="privatelink"
    onclick="toggle_private();">hide&nbsp;private</a>]</span></td></tr>
        <tr><td align="right"><span class="options"
            >[<a href="frames.html" target="_top">frames</a
            >]&nbsp;|&nbsp;<a href="screenlets.plugins.Gstreamer-pysrc.html"
            target="_top">no&nbsp;frames</a>]</span></td></tr>
      </table>
    </td>
  </tr>
</table>
<h1 class="epydoc">Source Code for <a href="screenlets.plugins.Gstreamer-module.html">Module screenlets.plugins.Gstreamer</a></h1>
<pre class="py-src">
<a name="L1"></a><tt class="py-lineno"> 1</tt>  <tt class="py-line"><tt class="py-keyword">import</tt> <tt class="py-name">pygtk</tt><tt class="py-op">,</tt> <tt class="py-name">gtk</tt><tt class="py-op">,</tt> <tt class="py-name">gobject</tt> </tt>
<a name="L2"></a><tt class="py-lineno"> 2</tt>  <tt class="py-line"><tt class="py-keyword">import</tt> <tt class="py-name">pygst</tt> </tt>
<a name="L3"></a><tt class="py-lineno"> 3</tt>  <tt class="py-line"><tt class="py-name">pygst</tt><tt class="py-op">.</tt><tt class="py-name">require</tt><tt class="py-op">(</tt><tt class="py-string">"0.10"</tt><tt class="py-op">)</tt> </tt>
<a name="L4"></a><tt class="py-lineno"> 4</tt>  <tt class="py-line"><tt class="py-keyword">import</tt> <tt class="py-name">gst</tt> </tt>
<a name="L5"></a><tt class="py-lineno"> 5</tt>  <tt class="py-line"> </tt>
<a name="gstreamer"></a><div id="gstreamer-def"><a name="L6"></a><tt class="py-lineno"> 6</tt> <a class="py-toggle" href="#" id="gstreamer-toggle" onclick="return toggle('gstreamer');">-</a><tt class="py-line"><tt class="py-keyword">class</tt> <a class="py-def-name" href="screenlets.plugins.Gstreamer.gstreamer-class.html">gstreamer</a><tt class="py-op">:</tt> </tt>
</div><div id="gstreamer-collapsed" style="display:none;" pad="++" indent="++++"></div><div id="gstreamer-expanded"><a name="L7"></a><tt class="py-lineno"> 7</tt>  <tt class="py-line"> </tt>
<a name="gstreamer.__init__"></a><div id="gstreamer.__init__-def"><a name="L8"></a><tt class="py-lineno"> 8</tt> <a class="py-toggle" href="#" id="gstreamer.__init__-toggle" onclick="return toggle('gstreamer.__init__');">-</a><tt class="py-line">        <tt class="py-keyword">def</tt> <a class="py-def-name" href="screenlets.plugins.Gstreamer.gstreamer-class.html#__init__">__init__</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="gstreamer.__init__-collapsed" style="display:none;" pad="++" indent="++++++++++++"></div><div id="gstreamer.__init__-expanded"><a name="L9"></a><tt class="py-lineno"> 9</tt>  <tt class="py-line">                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">player</tt> <tt class="py-op">=</tt> <tt class="py-name">gst</tt><tt class="py-op">.</tt><tt class="py-name">element_factory_make</tt><tt class="py-op">(</tt><tt class="py-string">"playbin"</tt><tt class="py-op">,</tt> <tt class="py-string">"player"</tt><tt class="py-op">)</tt> </tt>
<a name="L10"></a><tt class="py-lineno">10</tt>  <tt class="py-line">                <tt class="py-name">fakesink</tt> <tt class="py-op">=</tt> <tt class="py-name">gst</tt><tt class="py-op">.</tt><tt class="py-name">element_factory_make</tt><tt class="py-op">(</tt><tt class="py-string">'fakesink'</tt><tt class="py-op">,</tt> <tt class="py-string">"my-fakesink"</tt><tt class="py-op">)</tt> </tt>
<a name="L11"></a><tt class="py-lineno">11</tt>  <tt class="py-line">                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">player</tt><tt class="py-op">.</tt><tt class="py-name">set_property</tt><tt class="py-op">(</tt><tt class="py-string">"video-sink"</tt><tt class="py-op">,</tt> <tt class="py-name">fakesink</tt><tt class="py-op">)</tt> </tt>
<a name="L12"></a><tt class="py-lineno">12</tt>  <tt class="py-line">                <tt class="py-name">bus</tt> <tt class="py-op">=</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">player</tt><tt class="py-op">.</tt><tt class="py-name">get_bus</tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
<a name="L13"></a><tt class="py-lineno">13</tt>  <tt class="py-line">                <tt class="py-name">bus</tt><tt class="py-op">.</tt><tt class="py-name">add_signal_watch</tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
<a name="L14"></a><tt class="py-lineno">14</tt>  <tt class="py-line">                <tt class="py-name">bus</tt><tt class="py-op">.</tt><tt id="link-0" class="py-name" targets="Method screenlets.plugins.Amarok.AmarokAPI.connect()=screenlets.plugins.Amarok.AmarokAPI-class.html#connect,Method screenlets.plugins.Audacious.AudaciousAPI.connect()=screenlets.plugins.Audacious.AudaciousAPI-class.html#connect,Method screenlets.plugins.Banshee.BansheeAPI.connect()=screenlets.plugins.Banshee.BansheeAPI-class.html#connect,Method screenlets.plugins.Exaile.ExaileAPI.connect()=screenlets.plugins.Exaile.ExaileAPI-class.html#connect,Method screenlets.plugins.GenericPlayer.GenericAPI.connect()=screenlets.plugins.GenericPlayer.GenericAPI-class.html#connect,Method screenlets.plugins.Juk.JukAPI.connect()=screenlets.plugins.Juk.JukAPI-class.html#connect,Method screenlets.plugins.Kaffeine.KaffeineAPI.connect()=screenlets.plugins.Kaffeine.KaffeineAPI-class.html#connect,Method screenlets.plugins.LastFMProxy.LastFMProxyAPI.connect()=screenlets.plugins.LastFMProxy.LastFMProxyAPI-class.html#connect,Method screenlets.plugins.Listen.ListenAPI.connect()=screenlets.plugins.Listen.ListenAPI-class.html#connect,Method screenlets.plugins.Quodlibet.QuodlibetAPI.connect()=screenlets.plugins.Quodlibet.QuodlibetAPI-class.html#connect,Method screenlets.plugins.Rhythmbox.RhythmboxAPI.connect()=screenlets.plugins.Rhythmbox.RhythmboxAPI-class.html#connect,Method screenlets.plugins.Sonata.SonataAPI.connect()=screenlets.plugins.Sonata.SonataAPI-class.html#connect,Method screenlets.plugins.Songbird.SongbirdAPI.connect()=screenlets.plugins.Songbird.SongbirdAPI-class.html#connect,Function screenlets.plugins.mpdclient2.connect()=screenlets.plugins.mpdclient2-module.html#connect"><a title="screenlets.plugins.Amarok.AmarokAPI.connect
screenlets.plugins.Audacious.AudaciousAPI.connect
screenlets.plugins.Banshee.BansheeAPI.connect
screenlets.plugins.Exaile.ExaileAPI.connect
screenlets.plugins.GenericPlayer.GenericAPI.connect
screenlets.plugins.Juk.JukAPI.connect
screenlets.plugins.Kaffeine.KaffeineAPI.connect
screenlets.plugins.LastFMProxy.LastFMProxyAPI.connect
screenlets.plugins.Listen.ListenAPI.connect
screenlets.plugins.Quodlibet.QuodlibetAPI.connect
screenlets.plugins.Rhythmbox.RhythmboxAPI.connect
screenlets.plugins.Sonata.SonataAPI.connect
screenlets.plugins.Songbird.SongbirdAPI.connect
screenlets.plugins.mpdclient2.connect" class="py-name" href="#" onclick="return doclink('link-0', 'connect', 'link-0');">connect</a></tt><tt class="py-op">(</tt><tt class="py-string">'message'</tt><tt class="py-op">,</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-1" class="py-name" targets="Method screenlets.plugins.Gstreamer.gstreamer.on_message()=screenlets.plugins.Gstreamer.gstreamer-class.html#on_message"><a title="screenlets.plugins.Gstreamer.gstreamer.on_message" class="py-name" href="#" onclick="return doclink('link-1', 'on_message', 'link-1');">on_message</a></tt><tt class="py-op">)</tt> </tt>
<a name="L15"></a><tt class="py-lineno">15</tt>  <tt class="py-line"> </tt>
<a name="L16"></a><tt class="py-lineno">16</tt>  <tt class="py-line">                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">player</tt> <tt class="py-op">=</tt> <tt class="py-name">gst</tt><tt class="py-op">.</tt><tt class="py-name">Pipeline</tt><tt class="py-op">(</tt><tt class="py-string">"player"</tt><tt class="py-op">)</tt> </tt>
<a name="L17"></a><tt class="py-lineno">17</tt>  <tt class="py-line">                <tt class="py-name">source</tt> <tt class="py-op">=</tt> <tt class="py-name">gst</tt><tt class="py-op">.</tt><tt class="py-name">element_factory_make</tt><tt class="py-op">(</tt><tt class="py-string">"filesrc"</tt><tt class="py-op">,</tt> <tt class="py-string">"file-source"</tt><tt class="py-op">)</tt> </tt>
<a name="L18"></a><tt class="py-lineno">18</tt>  <tt class="py-line">                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">player</tt><tt class="py-op">.</tt><tt id="link-2" class="py-name" targets="Method screenlets.services.ScreenletService.add()=screenlets.services.ScreenletService-class.html#add"><a title="screenlets.services.ScreenletService.add" class="py-name" href="#" onclick="return doclink('link-2', 'add', 'link-2');">add</a></tt><tt class="py-op">(</tt><tt class="py-name">source</tt><tt class="py-op">)</tt> </tt>
<a name="L19"></a><tt class="py-lineno">19</tt>  <tt class="py-line">                <tt class="py-name">demuxer</tt> <tt class="py-op">=</tt> <tt class="py-name">gst</tt><tt class="py-op">.</tt><tt class="py-name">element_factory_make</tt><tt class="py-op">(</tt><tt class="py-string">"oggdemux"</tt><tt class="py-op">,</tt> <tt class="py-string">"demuxer"</tt><tt class="py-op">)</tt> </tt>
<a name="L20"></a><tt class="py-lineno">20</tt>  <tt class="py-line">                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">player</tt><tt class="py-op">.</tt><tt id="link-3" class="py-name"><a title="screenlets.services.ScreenletService.add" class="py-name" href="#" onclick="return doclink('link-3', 'add', 'link-2');">add</a></tt><tt class="py-op">(</tt><tt class="py-name">demuxer</tt><tt class="py-op">)</tt> </tt>
<a name="L21"></a><tt class="py-lineno">21</tt>  <tt class="py-line">                <tt class="py-name">demuxer</tt><tt class="py-op">.</tt><tt id="link-4" class="py-name"><a title="screenlets.plugins.Amarok.AmarokAPI.connect
screenlets.plugins.Audacious.AudaciousAPI.connect
screenlets.plugins.Banshee.BansheeAPI.connect
screenlets.plugins.Exaile.ExaileAPI.connect
screenlets.plugins.GenericPlayer.GenericAPI.connect
screenlets.plugins.Juk.JukAPI.connect
screenlets.plugins.Kaffeine.KaffeineAPI.connect
screenlets.plugins.LastFMProxy.LastFMProxyAPI.connect
screenlets.plugins.Listen.ListenAPI.connect
screenlets.plugins.Quodlibet.QuodlibetAPI.connect
screenlets.plugins.Rhythmbox.RhythmboxAPI.connect
screenlets.plugins.Sonata.SonataAPI.connect
screenlets.plugins.Songbird.SongbirdAPI.connect
screenlets.plugins.mpdclient2.connect" class="py-name" href="#" onclick="return doclink('link-4', 'connect', 'link-0');">connect</a></tt><tt class="py-op">(</tt><tt class="py-string">"pad-added"</tt><tt class="py-op">,</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-5" class="py-name" targets="Method screenlets.plugins.Gstreamer.gstreamer.demuxer_callback()=screenlets.plugins.Gstreamer.gstreamer-class.html#demuxer_callback"><a title="screenlets.plugins.Gstreamer.gstreamer.demuxer_callback" class="py-name" href="#" onclick="return doclink('link-5', 'demuxer_callback', 'link-5');">demuxer_callback</a></tt><tt class="py-op">)</tt> </tt>
<a name="L22"></a><tt class="py-lineno">22</tt>  <tt class="py-line">                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">audio_decoder</tt> <tt class="py-op">=</tt> <tt class="py-name">gst</tt><tt class="py-op">.</tt><tt class="py-name">element_factory_make</tt><tt class="py-op">(</tt><tt class="py-string">"vorbisdec"</tt><tt class="py-op">,</tt> <tt class="py-string">"vorbis-decoder"</tt><tt class="py-op">)</tt> </tt>
<a name="L23"></a><tt class="py-lineno">23</tt>  <tt class="py-line">                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">player</tt><tt class="py-op">.</tt><tt id="link-6" class="py-name"><a title="screenlets.services.ScreenletService.add" class="py-name" href="#" onclick="return doclink('link-6', 'add', 'link-2');">add</a></tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">audio_decoder</tt><tt class="py-op">)</tt> </tt>
<a name="L24"></a><tt class="py-lineno">24</tt>  <tt class="py-line">                <tt class="py-name">audioconv</tt> <tt class="py-op">=</tt> <tt class="py-name">gst</tt><tt class="py-op">.</tt><tt class="py-name">element_factory_make</tt><tt class="py-op">(</tt><tt class="py-string">"audioconvert"</tt><tt class="py-op">,</tt> <tt class="py-string">"converter"</tt><tt class="py-op">)</tt> </tt>
<a name="L25"></a><tt class="py-lineno">25</tt>  <tt class="py-line">                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">player</tt><tt class="py-op">.</tt><tt id="link-7" class="py-name"><a title="screenlets.services.ScreenletService.add" class="py-name" href="#" onclick="return doclink('link-7', 'add', 'link-2');">add</a></tt><tt class="py-op">(</tt><tt class="py-name">audioconv</tt><tt class="py-op">)</tt> </tt>
<a name="L26"></a><tt class="py-lineno">26</tt>  <tt class="py-line">                <tt class="py-name">audiosink</tt> <tt class="py-op">=</tt> <tt class="py-name">gst</tt><tt class="py-op">.</tt><tt class="py-name">element_factory_make</tt><tt class="py-op">(</tt><tt class="py-string">"autoaudiosink"</tt><tt class="py-op">,</tt> <tt class="py-string">"audio-output"</tt><tt class="py-op">)</tt> </tt>
<a name="L27"></a><tt class="py-lineno">27</tt>  <tt class="py-line">                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">player</tt><tt class="py-op">.</tt><tt id="link-8" class="py-name"><a title="screenlets.services.ScreenletService.add" class="py-name" href="#" onclick="return doclink('link-8', 'add', 'link-2');">add</a></tt><tt class="py-op">(</tt><tt class="py-name">audiosink</tt><tt class="py-op">)</tt> </tt>
<a name="L28"></a><tt class="py-lineno">28</tt>  <tt class="py-line"> </tt>
<a name="L29"></a><tt class="py-lineno">29</tt>  <tt class="py-line">                <tt class="py-name">gst</tt><tt class="py-op">.</tt><tt class="py-name">element_link_many</tt><tt class="py-op">(</tt><tt class="py-name">source</tt><tt class="py-op">,</tt> <tt class="py-name">demuxer</tt><tt class="py-op">)</tt> </tt>
<a name="L30"></a><tt class="py-lineno">30</tt>  <tt class="py-line">                <tt class="py-name">gst</tt><tt class="py-op">.</tt><tt class="py-name">element_link_many</tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">audio_decoder</tt><tt class="py-op">,</tt> <tt class="py-name">audioconv</tt><tt class="py-op">,</tt> <tt class="py-name">audiosink</tt><tt class="py-op">)</tt> </tt>
<a name="L31"></a><tt class="py-lineno">31</tt>  <tt class="py-line"> </tt>
<a name="L32"></a><tt class="py-lineno">32</tt>  <tt class="py-line">                <tt class="py-name">bus</tt> <tt class="py-op">=</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">player</tt><tt class="py-op">.</tt><tt class="py-name">get_bus</tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
<a name="L33"></a><tt class="py-lineno">33</tt>  <tt class="py-line">                <tt class="py-name">bus</tt><tt class="py-op">.</tt><tt class="py-name">add_signal_watch</tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
<a name="L34"></a><tt class="py-lineno">34</tt>  <tt class="py-line">                <tt class="py-name">bus</tt><tt class="py-op">.</tt><tt id="link-9" class="py-name"><a title="screenlets.plugins.Amarok.AmarokAPI.connect
screenlets.plugins.Audacious.AudaciousAPI.connect
screenlets.plugins.Banshee.BansheeAPI.connect
screenlets.plugins.Exaile.ExaileAPI.connect
screenlets.plugins.GenericPlayer.GenericAPI.connect
screenlets.plugins.Juk.JukAPI.connect
screenlets.plugins.Kaffeine.KaffeineAPI.connect
screenlets.plugins.LastFMProxy.LastFMProxyAPI.connect
screenlets.plugins.Listen.ListenAPI.connect
screenlets.plugins.Quodlibet.QuodlibetAPI.connect
screenlets.plugins.Rhythmbox.RhythmboxAPI.connect
screenlets.plugins.Sonata.SonataAPI.connect
screenlets.plugins.Songbird.SongbirdAPI.connect
screenlets.plugins.mpdclient2.connect" class="py-name" href="#" onclick="return doclink('link-9', 'connect', 'link-0');">connect</a></tt><tt class="py-op">(</tt><tt class="py-string">"message"</tt><tt class="py-op">,</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-10" class="py-name"><a title="screenlets.plugins.Gstreamer.gstreamer.on_message" class="py-name" href="#" onclick="return doclink('link-10', 'on_message', 'link-1');">on_message</a></tt><tt class="py-op">)</tt> </tt>
</div><a name="L35"></a><tt class="py-lineno">35</tt>  <tt class="py-line"> </tt>
<a name="L36"></a><tt class="py-lineno">36</tt>  <tt class="py-line"> </tt>
<a name="gstreamer.demuxer_callback"></a><div id="gstreamer.demuxer_callback-def"><a name="L37"></a><tt class="py-lineno">37</tt> <a class="py-toggle" href="#" id="gstreamer.demuxer_callback-toggle" onclick="return toggle('gstreamer.demuxer_callback');">-</a><tt class="py-line">        <tt class="py-keyword">def</tt> <a class="py-def-name" href="screenlets.plugins.Gstreamer.gstreamer-class.html#demuxer_callback">demuxer_callback</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt> <tt class="py-param">demuxer</tt><tt class="py-op">,</tt> <tt class="py-param">pad</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="gstreamer.demuxer_callback-collapsed" style="display:none;" pad="++" indent="++++++++++++"></div><div id="gstreamer.demuxer_callback-expanded"><a name="L38"></a><tt class="py-lineno">38</tt>  <tt class="py-line">                <tt class="py-name">adec_pad</tt> <tt class="py-op">=</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">audio_decoder</tt><tt class="py-op">.</tt><tt class="py-name">get_pad</tt><tt class="py-op">(</tt><tt class="py-string">"sink"</tt><tt class="py-op">)</tt> </tt>
<a name="L39"></a><tt class="py-lineno">39</tt>  <tt class="py-line">                <tt class="py-name">pad</tt><tt class="py-op">.</tt><tt class="py-name">link</tt><tt class="py-op">(</tt><tt class="py-name">adec_pad</tt><tt class="py-op">)</tt> </tt>
</div><a name="L40"></a><tt class="py-lineno">40</tt>  <tt class="py-line"> </tt>
<a name="L41"></a><tt class="py-lineno">41</tt>  <tt class="py-line"> </tt>
<a name="gstreamer.start"></a><div id="gstreamer.start-def"><a name="L42"></a><tt class="py-lineno">42</tt> <a class="py-toggle" href="#" id="gstreamer.start-toggle" onclick="return toggle('gstreamer.start');">-</a><tt class="py-line">        <tt class="py-keyword">def</tt> <a class="py-def-name" href="screenlets.plugins.Gstreamer.gstreamer-class.html#start">start</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="gstreamer.start-collapsed" style="display:none;" pad="++" indent="++++++++++++"></div><div id="gstreamer.start-expanded"><a name="L43"></a><tt class="py-lineno">43</tt>  <tt class="py-line">                <tt class="py-keyword">try</tt><tt class="py-op">:</tt>                     </tt>
<a name="L44"></a><tt class="py-lineno">44</tt>  <tt class="py-line">                        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">player</tt><tt class="py-op">.</tt><tt class="py-name">set_property</tt><tt class="py-op">(</tt><tt class="py-string">'uri'</tt><tt class="py-op">,</tt> <tt class="py-name">ta</tt><tt class="py-op">)</tt> </tt>
<a name="L45"></a><tt class="py-lineno">45</tt>  <tt class="py-line">                        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">player</tt><tt class="py-op">.</tt><tt class="py-name">set_state</tt><tt class="py-op">(</tt><tt class="py-name">gst</tt><tt class="py-op">.</tt><tt class="py-name">STATE_PLAYING</tt><tt class="py-op">)</tt> </tt>
<a name="L46"></a><tt class="py-lineno">46</tt>  <tt class="py-line">                <tt class="py-keyword">except</tt> <tt class="py-name">Exception</tt><tt class="py-op">,</tt> <tt class="py-name">ex</tt><tt class="py-op">:</tt> </tt>
<a name="L47"></a><tt class="py-lineno">47</tt>  <tt class="py-line">                        <tt class="py-keyword">print</tt> <tt class="py-string">'unable to connect'</tt> </tt>
</div><a name="L48"></a><tt class="py-lineno">48</tt>  <tt class="py-line"> </tt>
<a name="gstreamer.stop"></a><div id="gstreamer.stop-def"><a name="L49"></a><tt class="py-lineno">49</tt> <a class="py-toggle" href="#" id="gstreamer.stop-toggle" onclick="return toggle('gstreamer.stop');">-</a><tt class="py-line">        <tt class="py-keyword">def</tt> <a class="py-def-name" href="screenlets.plugins.Gstreamer.gstreamer-class.html#stop">stop</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="gstreamer.stop-collapsed" style="display:none;" pad="++" indent="++++++++++++"></div><div id="gstreamer.stop-expanded"><a name="L50"></a><tt class="py-lineno">50</tt>  <tt class="py-line">                         </tt>
<a name="L51"></a><tt class="py-lineno">51</tt>  <tt class="py-line">                        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">player</tt><tt class="py-op">.</tt><tt class="py-name">set_state</tt><tt class="py-op">(</tt><tt class="py-name">gst</tt><tt class="py-op">.</tt><tt class="py-name">STATE_NULL</tt><tt class="py-op">)</tt> </tt>
</div><a name="L52"></a><tt class="py-lineno">52</tt>  <tt class="py-line"> </tt>
<a name="gstreamer.on_message"></a><div id="gstreamer.on_message-def"><a name="L53"></a><tt class="py-lineno">53</tt> <a class="py-toggle" href="#" id="gstreamer.on_message-toggle" onclick="return toggle('gstreamer.on_message');">-</a><tt class="py-line">        <tt class="py-keyword">def</tt> <a class="py-def-name" href="screenlets.plugins.Gstreamer.gstreamer-class.html#on_message">on_message</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt> <tt class="py-param">bus</tt><tt class="py-op">,</tt> <tt class="py-param">message</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="gstreamer.on_message-collapsed" style="display:none;" pad="++" indent="++++++++++++"></div><div id="gstreamer.on_message-expanded"><a name="L54"></a><tt class="py-lineno">54</tt>  <tt class="py-line">                <tt class="py-name">t</tt> <tt class="py-op">=</tt> <tt class="py-name">message</tt><tt class="py-op">.</tt><tt class="py-name">type</tt> </tt>
<a name="L55"></a><tt class="py-lineno">55</tt>  <tt class="py-line">                <tt class="py-keyword">if</tt> <tt class="py-name">t</tt> <tt class="py-op">==</tt> <tt class="py-name">gst</tt><tt class="py-op">.</tt><tt class="py-name">MESSAGE_EOS</tt><tt class="py-op">:</tt> </tt>
<a name="L56"></a><tt class="py-lineno">56</tt>  <tt class="py-line">                        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">player</tt><tt class="py-op">.</tt><tt class="py-name">set_state</tt><tt class="py-op">(</tt><tt class="py-name">gst</tt><tt class="py-op">.</tt><tt class="py-name">STATE_NULL</tt><tt class="py-op">)</tt> </tt>
<a name="L57"></a><tt class="py-lineno">57</tt>  <tt class="py-line"> </tt>
<a name="L58"></a><tt class="py-lineno">58</tt>  <tt class="py-line">                <tt class="py-keyword">elif</tt> <tt class="py-name">t</tt> <tt class="py-op">==</tt> <tt class="py-name">gst</tt><tt class="py-op">.</tt><tt class="py-name">MESSAGE_ERROR</tt><tt class="py-op">:</tt> </tt>
<a name="L59"></a><tt class="py-lineno">59</tt>  <tt class="py-line">                        <tt class="py-name">err</tt><tt class="py-op">,</tt> <tt id="link-11" class="py-name" targets="Method screenlets.services.ScreenletService.debug()=screenlets.services.ScreenletService-class.html#debug"><a title="screenlets.services.ScreenletService.debug" class="py-name" href="#" onclick="return doclink('link-11', 'debug', 'link-11');">debug</a></tt> <tt class="py-op">=</tt> <tt class="py-name">message</tt><tt class="py-op">.</tt><tt class="py-name">parse_error</tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
<a name="L60"></a><tt class="py-lineno">60</tt>  <tt class="py-line">                        <tt class="py-keyword">print</tt> <tt class="py-string">"Error: %s"</tt> <tt class="py-op">%</tt> <tt class="py-name">err</tt><tt class="py-op">,</tt> <tt id="link-12" class="py-name"><a title="screenlets.services.ScreenletService.debug" class="py-name" href="#" onclick="return doclink('link-12', 'debug', 'link-11');">debug</a></tt> </tt>
<a name="L61"></a><tt class="py-lineno">61</tt>  <tt class="py-line">                        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">player</tt><tt class="py-op">.</tt><tt class="py-name">set_state</tt><tt class="py-op">(</tt><tt class="py-name">gst</tt><tt class="py-op">.</tt><tt class="py-name">STATE_NULL</tt><tt class="py-op">)</tt> </tt>
</div><a name="L62"></a><tt class="py-lineno">62</tt>  <tt class="py-line"> </tt>
<a name="gstreamer.rewind_callback"></a><div id="gstreamer.rewind_callback-def"><a name="L63"></a><tt class="py-lineno">63</tt> <a class="py-toggle" href="#" id="gstreamer.rewind_callback-toggle" onclick="return toggle('gstreamer.rewind_callback');">-</a><tt class="py-line">        <tt class="py-keyword">def</tt> <a class="py-def-name" href="screenlets.plugins.Gstreamer.gstreamer-class.html#rewind_callback">rewind_callback</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt> <tt class="py-param">w</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="gstreamer.rewind_callback-collapsed" style="display:none;" pad="++" indent="++++++++++++"></div><div id="gstreamer.rewind_callback-expanded"><a name="L64"></a><tt class="py-lineno">64</tt>  <tt class="py-line">                <tt class="py-name">pos_int</tt> <tt class="py-op">=</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">player</tt><tt class="py-op">.</tt><tt class="py-name">query_position</tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">time_format</tt><tt class="py-op">,</tt> <tt class="py-name">None</tt><tt class="py-op">)</tt><tt class="py-op">[</tt><tt class="py-number">0</tt><tt class="py-op">]</tt> </tt>
<a name="L65"></a><tt class="py-lineno">65</tt>  <tt class="py-line">                <tt class="py-name">seek_ns</tt> <tt class="py-op">=</tt> <tt class="py-name">pos_int</tt> <tt class="py-op">-</tt> <tt class="py-op">(</tt><tt class="py-number">10</tt> <tt class="py-op">*</tt> <tt class="py-number">1000000000</tt><tt class="py-op">)</tt> </tt>
<a name="L66"></a><tt class="py-lineno">66</tt>  <tt class="py-line">                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">player</tt><tt class="py-op">.</tt><tt class="py-name">seek_simple</tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">time_format</tt><tt class="py-op">,</tt> <tt class="py-name">gst</tt><tt class="py-op">.</tt><tt class="py-name">SEEK_FLAG_FLUSH</tt><tt class="py-op">,</tt> <tt class="py-name">seek_ns</tt><tt class="py-op">)</tt> </tt>
</div><a name="L67"></a><tt class="py-lineno">67</tt>  <tt class="py-line">                 </tt>
<a name="gstreamer.forward_callback"></a><div id="gstreamer.forward_callback-def"><a name="L68"></a><tt class="py-lineno">68</tt> <a class="py-toggle" href="#" id="gstreamer.forward_callback-toggle" onclick="return toggle('gstreamer.forward_callback');">-</a><tt class="py-line">        <tt class="py-keyword">def</tt> <a class="py-def-name" href="screenlets.plugins.Gstreamer.gstreamer-class.html#forward_callback">forward_callback</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt> <tt class="py-param">w</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="gstreamer.forward_callback-collapsed" style="display:none;" pad="++" indent="++++++++++++"></div><div id="gstreamer.forward_callback-expanded"><a name="L69"></a><tt class="py-lineno">69</tt>  <tt class="py-line">                <tt class="py-name">pos_int</tt> <tt class="py-op">=</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">player</tt><tt class="py-op">.</tt><tt class="py-name">query_position</tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">time_format</tt><tt class="py-op">,</tt> <tt class="py-name">None</tt><tt class="py-op">)</tt><tt class="py-op">[</tt><tt class="py-number">0</tt><tt class="py-op">]</tt> </tt>
<a name="L70"></a><tt class="py-lineno">70</tt>  <tt class="py-line">                <tt class="py-name">seek_ns</tt> <tt class="py-op">=</tt> <tt class="py-name">pos_int</tt> <tt class="py-op">+</tt> <tt class="py-op">(</tt><tt class="py-number">10</tt> <tt class="py-op">*</tt> <tt class="py-number">1000000000</tt><tt class="py-op">)</tt> </tt>
<a name="L71"></a><tt class="py-lineno">71</tt>  <tt class="py-line">                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">player</tt><tt class="py-op">.</tt><tt class="py-name">seek_simple</tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">time_format</tt><tt class="py-op">,</tt> <tt class="py-name">gst</tt><tt class="py-op">.</tt><tt class="py-name">SEEK_FLAG_FLUSH</tt><tt class="py-op">,</tt> <tt class="py-name">seek_ns</tt><tt class="py-op">)</tt> </tt>
</div><a name="L72"></a><tt class="py-lineno">72</tt>  <tt class="py-line">         </tt>
<a name="gstreamer.convert_ns"></a><div id="gstreamer.convert_ns-def"><a name="L73"></a><tt class="py-lineno">73</tt> <a class="py-toggle" href="#" id="gstreamer.convert_ns-toggle" onclick="return toggle('gstreamer.convert_ns');">-</a><tt class="py-line">        <tt class="py-keyword">def</tt> <a class="py-def-name" href="screenlets.plugins.Gstreamer.gstreamer-class.html#convert_ns">convert_ns</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt> <tt class="py-param">time_int</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="gstreamer.convert_ns-collapsed" style="display:none;" pad="++" indent="++++++++++++"></div><div id="gstreamer.convert_ns-expanded"><a name="L74"></a><tt class="py-lineno">74</tt>  <tt class="py-line">                <tt class="py-name">time_int</tt> <tt class="py-op">=</tt> <tt class="py-name">time_int</tt> <tt class="py-op">/</tt> <tt class="py-number">1000000000</tt> </tt>
<a name="L75"></a><tt class="py-lineno">75</tt>  <tt class="py-line">                <tt class="py-name">time_str</tt> <tt class="py-op">=</tt> <tt class="py-string">""</tt> </tt>
<a name="L76"></a><tt class="py-lineno">76</tt>  <tt class="py-line">                <tt class="py-keyword">if</tt> <tt class="py-name">time_int</tt> <tt class="py-op">&gt;=</tt> <tt class="py-number">3600</tt><tt class="py-op">:</tt> </tt>
<a name="L77"></a><tt class="py-lineno">77</tt>  <tt class="py-line">                        <tt class="py-name">_hours</tt> <tt class="py-op">=</tt> <tt class="py-name">time_int</tt> <tt class="py-op">/</tt> <tt class="py-number">3600</tt> </tt>
<a name="L78"></a><tt class="py-lineno">78</tt>  <tt class="py-line">                        <tt class="py-name">time_int</tt> <tt class="py-op">=</tt> <tt class="py-name">time_int</tt> <tt class="py-op">-</tt> <tt class="py-op">(</tt><tt class="py-name">_hours</tt> <tt class="py-op">*</tt> <tt class="py-number">3600</tt><tt class="py-op">)</tt> </tt>
<a name="L79"></a><tt class="py-lineno">79</tt>  <tt class="py-line">                        <tt class="py-name">time_str</tt> <tt class="py-op">=</tt> <tt id="link-13" class="py-name" targets="Method screenlets.plugins.Convert.Converter.str()=screenlets.plugins.Convert.Converter-class.html#str"><a title="screenlets.plugins.Convert.Converter.str" class="py-name" href="#" onclick="return doclink('link-13', 'str', 'link-13');">str</a></tt><tt class="py-op">(</tt><tt class="py-name">_hours</tt><tt class="py-op">)</tt> <tt class="py-op">+</tt> <tt class="py-string">":"</tt> </tt>
<a name="L80"></a><tt class="py-lineno">80</tt>  <tt class="py-line">                <tt class="py-keyword">if</tt> <tt class="py-name">time_int</tt> <tt class="py-op">&gt;=</tt> <tt class="py-number">600</tt><tt class="py-op">:</tt> </tt>
<a name="L81"></a><tt class="py-lineno">81</tt>  <tt class="py-line">                        <tt class="py-name">_mins</tt> <tt class="py-op">=</tt> <tt class="py-name">time_int</tt> <tt class="py-op">/</tt> <tt class="py-number">60</tt> </tt>
<a name="L82"></a><tt class="py-lineno">82</tt>  <tt class="py-line">                        <tt class="py-name">time_int</tt> <tt class="py-op">=</tt> <tt class="py-name">time_int</tt> <tt class="py-op">-</tt> <tt class="py-op">(</tt><tt class="py-name">_mins</tt> <tt class="py-op">*</tt> <tt class="py-number">60</tt><tt class="py-op">)</tt> </tt>
<a name="L83"></a><tt class="py-lineno">83</tt>  <tt class="py-line">                        <tt class="py-name">time_str</tt> <tt class="py-op">=</tt> <tt class="py-name">time_str</tt> <tt class="py-op">+</tt> <tt id="link-14" class="py-name"><a title="screenlets.plugins.Convert.Converter.str" class="py-name" href="#" onclick="return doclink('link-14', 'str', 'link-13');">str</a></tt><tt class="py-op">(</tt><tt class="py-name">_mins</tt><tt class="py-op">)</tt> <tt class="py-op">+</tt> <tt class="py-string">":"</tt> </tt>
<a name="L84"></a><tt class="py-lineno">84</tt>  <tt class="py-line">                <tt class="py-keyword">elif</tt> <tt class="py-name">time_int</tt> <tt class="py-op">&gt;=</tt> <tt class="py-number">60</tt><tt class="py-op">:</tt> </tt>
<a name="L85"></a><tt class="py-lineno">85</tt>  <tt class="py-line">                        <tt class="py-name">_mins</tt> <tt class="py-op">=</tt> <tt class="py-name">time_int</tt> <tt class="py-op">/</tt> <tt class="py-number">60</tt> </tt>
<a name="L86"></a><tt class="py-lineno">86</tt>  <tt class="py-line">                        <tt class="py-name">time_int</tt> <tt class="py-op">=</tt> <tt class="py-name">time_int</tt> <tt class="py-op">-</tt> <tt class="py-op">(</tt><tt class="py-name">_mins</tt> <tt class="py-op">*</tt> <tt class="py-number">60</tt><tt class="py-op">)</tt> </tt>
<a name="L87"></a><tt class="py-lineno">87</tt>  <tt class="py-line">                        <tt class="py-name">time_str</tt> <tt class="py-op">=</tt> <tt class="py-name">time_str</tt> <tt class="py-op">+</tt> <tt class="py-string">"0"</tt> <tt class="py-op">+</tt> <tt id="link-15" class="py-name"><a title="screenlets.plugins.Convert.Converter.str" class="py-name" href="#" onclick="return doclink('link-15', 'str', 'link-13');">str</a></tt><tt class="py-op">(</tt><tt class="py-name">_mins</tt><tt class="py-op">)</tt> <tt class="py-op">+</tt> <tt class="py-string">":"</tt> </tt>
<a name="L88"></a><tt class="py-lineno">88</tt>  <tt class="py-line">                <tt class="py-keyword">else</tt><tt class="py-op">:</tt> </tt>
<a name="L89"></a><tt class="py-lineno">89</tt>  <tt class="py-line">                        <tt class="py-name">time_str</tt> <tt class="py-op">=</tt> <tt class="py-name">time_str</tt> <tt class="py-op">+</tt> <tt class="py-string">"00:"</tt> </tt>
<a name="L90"></a><tt class="py-lineno">90</tt>  <tt class="py-line">                <tt class="py-keyword">if</tt> <tt class="py-name">time_int</tt> <tt class="py-op">&gt;</tt> <tt class="py-number">9</tt><tt class="py-op">:</tt> </tt>
<a name="L91"></a><tt class="py-lineno">91</tt>  <tt class="py-line">                        <tt class="py-name">time_str</tt> <tt class="py-op">=</tt> <tt class="py-name">time_str</tt> <tt class="py-op">+</tt> <tt id="link-16" class="py-name"><a title="screenlets.plugins.Convert.Converter.str" class="py-name" href="#" onclick="return doclink('link-16', 'str', 'link-13');">str</a></tt><tt class="py-op">(</tt><tt class="py-name">time_int</tt><tt class="py-op">)</tt> </tt>
<a name="L92"></a><tt class="py-lineno">92</tt>  <tt class="py-line">                <tt class="py-keyword">else</tt><tt class="py-op">:</tt> </tt>
<a name="L93"></a><tt class="py-lineno">93</tt>  <tt class="py-line">                        <tt class="py-name">time_str</tt> <tt class="py-op">=</tt> <tt class="py-name">time_str</tt> <tt class="py-op">+</tt> <tt class="py-string">"0"</tt> <tt class="py-op">+</tt> <tt id="link-17" class="py-name"><a title="screenlets.plugins.Convert.Converter.str" class="py-name" href="#" onclick="return doclink('link-17', 'str', 'link-13');">str</a></tt><tt class="py-op">(</tt><tt class="py-name">time_int</tt><tt class="py-op">)</tt> </tt>
<a name="L94"></a><tt class="py-lineno">94</tt>  <tt class="py-line">                         </tt>
<a name="L95"></a><tt class="py-lineno">95</tt>  <tt class="py-line">                <tt class="py-keyword">return</tt> <tt class="py-name">time_str</tt> </tt>
</div></div><a name="L96"></a><tt class="py-lineno">96</tt>  <tt class="py-line"> </tt><script type="text/javascript">
<!--
expandto(location.href);
// -->
</script>
</pre>
<br />
<!-- ==================== NAVIGATION BAR ==================== -->
<table class="navbar" border="0" width="100%" cellpadding="0"
       bgcolor="#a0c0ff" cellspacing="0">
  <tr valign="middle">
  <!-- Home link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="screenlets-module.html">Home</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Tree link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="module-tree.html">Trees</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Index link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="identifier-index.html">Indices</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Help link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="help.html">Help</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Project homepage -->
      <th class="navbar" align="right" width="100%">
        <table border="0" cellpadding="0" cellspacing="0">
          <tr><th class="navbar" align="center"
            >Screenlets 0.1.2</th>
          </tr></table></th>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%%">
  <tr>
    <td align="left" class="footer">
    Generated by Epydoc 3.0beta1 on Wed Jun  4 18:53:01 2008
    </td>
    <td align="right" class="footer">
      <a href="http://epydoc.sourceforge.net">http://epydoc.sourceforge.net</a>
    </td>
  </tr>
</table>

<script type="text/javascript">
  <!--
  // Private objects are initially displayed (because if
  // javascript is turned off then we want them to be
  // visible); but by default, we want to hide them.  So hide
  // them unless we have a cookie that says to show them.
  checkCookie()
  // -->
</script>
  
</body>
</html>
